[:Entry]

                                                              
 UML (Unified Modeling Language) class diagram for City Entry 
                                                              

abstract class CityEntry {
    String name;
    String address;
    String phone;
    CityEntry(String n, String a, String p) {
        name = n;
        address = a;
        phone = p;
    }
    String getName() {
        return name;
    }
    String getAddress() {
        return address;
    }
    String getPhone() {
        return phone;
    }
}
abstract class NonResidentialEntry extends CityEntry {
    String city;
    String state;
    NonResidentialEntry(String n, String a, String p, String c, String s) {
        super(n, a, p);
        city = c;
        state = s;
    }
    String getCity() {
        return city;
    }
    String getState() {
        return state;
    }
}
class BusinessEntry extends NonResidentialEntry {
    BusinessEntry(String n, String a, String p, String c, String s) {
        super(n, a, p, c, s);
    }
}
class GovernmentEntry extends NonResidentialEntry {
    String government;
    GovernmentEntry(String n, String a, String p, String c, String s, String g) {
        super(n, a, p, c, s);
        government = g;
    }
    String getGovernment() {
        return government;
    }
}
class ResidentialEntry extends CityEntry {
    ResidentialEntry(String n, String a, String p) {
        super(n, a, p);
    }
}
